var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { requestStatuses } from 'redux-resource';

var actionTypes = {
  RESET_RESOURCE: 'RESET_RESOURCE'
};

function resetResource(resourceName) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      request = _ref.request,
      list = _ref.list;

  return {
    type: 'RESET_RESOURCE',
    resourceName: resourceName,
    request: request,
    list: list
  };
}

function reset(resourceName) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return function (state, action) {
    if (action.type !== actionTypes.RESET_RESOURCE || action.resourceName !== resourceName) {
      return state;
    }

    var request = action.request,
        list = action.list;


    if (!request && !list) {
      return _extends({
        resources: {},
        meta: {},
        lists: {},
        requests: {}
      }, options.initialState);
    }

    var newState = _extends({}, state);

    if (request) {
      newState.requests = _extends({}, state.requests, _defineProperty({}, request, {
        ids: [],
        status: requestStatuses.NULL
      }));
    }

    if (list) {
      newState.lists = _extends({}, state.lists, _defineProperty({}, list, []));
    }

    return newState;
  };
}

reset.actionTypes = actionTypes;
reset.resetResource = resetResource;

export default reset;